<template>
  <v-col>
    <v-row class="ml-4">
      <span class="titulo">PRODUCTOS Y SERVICIOS</span>
    </v-row>
    <v-btn
      v-if="$vuetify.breakpoint.smAndDown"
      class="flotante"
      fab
      color="accent"
      bottom
      right
      @click="abrirForm"
    >
      <v-icon class="fal fa-plus" dark />
    </v-btn>
    <lista-productos :seleccionable="false" @onEdit="editarForm" @onAbrirStock="dialogStockCritico = !dialogStockCritico" @onRenovar="renovarForm" @onAbrir="abrirForm" />
    <v-dialog v-model="dialogStock" width="500">
      <form-renovar-stock v-if="dialogStock" :producto="producto" @onClose="closeDialogStock" />
    </v-dialog>
    <v-dialog v-model="dialogProductos" width="500" :fullscreen="$vuetify.breakpoint.smAndDown">
      <form-productos v-if="dialogProductos" :producto="producto" @onClose="closeDialog" />
    </v-dialog>
    <v-dialog v-model="dialogStockCritico" width="500" :fullscreen="$vuetify.breakpoint.smAndDown">
      <form-reporte-crítico v-if="dialogStockCritico" @onClose="dialogStockCritico = !dialogStockCritico" />
    </v-dialog>
  </v-col>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import { Producto } from '~/core/models/producto'
import ListaProductos from '~/components/productos/listaProductos.vue'
import FormRenovarStock from '~/components/productos/formRenovarStock.vue'
import FormProductos from '~/components/productos/formProductos.vue'
import { AppStore } from '~/store/AppStore'
import { ProductosStore } from '~/store/ProductosStore'
import FormReporteCrítico from '~/components/productos/formReporteCrítico.vue'
    @Component({
      components: { FormReporteCrítico, FormProductos, FormRenovarStock, ListaProductos },
      head: { title: 'Productos' },
      middleware: 'auth'
    })
export default class productos extends Vue {
        dialogProductos:boolean = false;
        dialogStock:boolean = false;
        dialogStockCritico:boolean = false;

        producto:Producto = null;

        abrirForm () {
          this.dialogProductos = true
        }

        editarForm (val) {
          this.producto = val
          this.dialogProductos = true
        }

        renovarForm (val) {
          this.producto = val
          this.dialogStock = true
        }

        closeDialog () {
          this.dialogProductos = false
          this.producto = null
        }

        closeDialogStock () {
          this.dialogStock = false
          this.producto = null
        }

        mounted () {
          productos.descargardatos()
        }

        private static async descargardatos () {
          AppStore.SHOW_LOADING('Cargando...')

          try {
            await ProductosStore.descargarListaProductos()
          } catch (e) {
          }

          AppStore.HIDE_LOADING()
        }
}
</script>

<style lang="scss">

</style>
